#include <bits/stdc++.h>

using namespace std;

bool DIR = true;

using T = int;
struct Dinic {
    struct Edge { int from, to, nxt; T cap, flow; };

    vector<Edge> es;
    vector<int> graph, at, dist, q;

    Dinic(int n) : graph(n, -1) {}

    int AddEdge(int a, int b, T c, bool dir = true) {
        auto add = [&](int a, int b, T c) {
            es.push_back({a, b, graph[a], c, 0});
            graph[a] = es.size() - 1;
        };
        add(a, b, c); add(b, a, dir ? 0 : c);
        return es.size() - 2;
    }

    bool bfs(int src, int dest) {
        dist.assign(graph.size(), -1); q.clear();
        dist[src] = 0; q.push_back(src);
        for (int i = 0; i < (int)q.size(); ++i) {
            int node = q[i];
            for (int ei = graph[node]; ei >= 0; ei = es[ei].nxt) {
                const auto &e = es[ei];
                if (dist[e.to] == -1 && e.cap > e.flow) {
                    dist[e.to] = dist[node] + 1;
                    q.push_back(e.to);
                }
            }
        }
        return dist[dest] != -1;
    }

    T dfs(int node, int dest, T need) {
        if (!need || node == dest) return need;
        T ret = 0;
        for (int& ei = at[node]; ei != -1; ei = es[ei].nxt) {
            const auto &e = es[ei];
            if (dist[e.to] != dist[node] + 1) continue;
            if (T now = dfs(e.to, dest, min(need, e.cap - e.flow))) {
                es[ei].flow += now;
                es[ei ^ 1].flow -= now;
                ret += now; need -= now;
            }
            if (!need) break;
        }
        return ret;
    }

    T Compute(int src, int dest) {
        T ret = 0;
        while (bfs(src, dest)) {
            at = graph;
            ret += dfs(src, dest, numeric_limits<T>::max());
        }
        return ret;
    }

    bool SideOfCut(int x) { return dist[x] == -1; }

    vector<int> pizda_dfs(int node, int dest) {
        if (node == dest) {
            return {node};
        }
        for (int ei = graph[node]; ei != -1; ei = es[ei].nxt) {
            const auto &e = es[ei];
            if (e.flow > 0) {
               es[ei].flow -= 1;
               es[ei ^ 1].flow += 1;
               auto pula = pizda_dfs(e.to, dest);
               pula.emplace_back(node);
               return pula;
            }
        }
        return {-1};
    }

    vector<vector<int>> pizda(int src, int dest) {
        int flow = Compute(src, dest);
        vector<vector<int>> pule;
        while (flow--) {
            pule.emplace_back(pizda_dfs(src, dest)); 
        }
        return pule;
    }
};

struct EulerWalk {
    int n;
    vector<vector<pair<int, int>>> graph;
    vector<int> cap, walk, buf, deg;

    EulerWalk(int n): n(n), graph(n + 1), deg(n + 1) {}

    int AddEdge(int a, int b, int c = 1) {
        int ret = cap.size();
        graph[b].emplace_back(a, ret);
        if(!DIR) graph[a].emplace_back(b, ret);
        cap.push_back(c);
        deg[a] += c;
        deg[b] -= c;
        if(!DIR) deg[a] %= 2, deg[b] %= 2;

        return ret;
    }

    void dfs(int node) {
        while(graph[node].size()) {
            auto [vec, ei] = graph[node].back();
            if(!cap[ei]) graph[node].pop_back();
            else --cap[ei], dfs(vec);
        }
        walk.push_back(node);
    }

    template<typename CB>
    void Go(CB&& cb) {
        for(int i = 0; i <= n; ++i) {
            if(deg[i] < 0) AddEdge(i, n, -deg[i]);
            if(deg[i] > 0) AddEdge(n, i, +deg[i]);
            assert(deg[i] == 0);
        }

        for(int i = n; i >= 0; --i) {
            dfs(i), walk.push_back(n);
        }

        for(int i = 0, j = 0; i < (int)walk.size(); i = j + 1) {
            for(j = i; walk[j] < n; ++j);
            if(j - i > 1) cb(walk.begin() + i, walk.begin() + j);
        }
    }
};

map<string, int> Nr;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    string arrive, depart;
    cin >> depart;
    cin >> arrive;

    unordered_map<string, vector<int>> mapula;

    for (int i = 0; i < n; i++) {
        string a = depart[i];
        string d = arrive[i];
        string plm = a + d;
        string a = "a";
        a[0] = 
        Nr[string(depart[i]) + arrive[i]]++;
        mapula[string(depart[i]) + arrive[i]].push_back(i);
    }

    vector<string> ids_to_string_pula = {
        "",
        "-C",
        "-M",
        "C-",
        "C-",
        "CM",
        "CM",
        "MC",
        "MC",
        "M-",
        "M-",
        ""
    };

    Dinic nw(12);
    nw.AddEdge(0, 1, Nr["-C"]);
    nw.AddEdge(0, 2, Nr["-M"]);
    nw.AddEdge(1, 3, 1e9);
    nw.AddEdge(1, 5, 1e9);
    nw.AddEdge(2, 7, 1e9);
    nw.AddEdge(2, 9, 1e9);
    nw.AddEdge(3, 4, Nr["C-"]);
    nw.AddEdge(5, 6, Nr["CM"]);
    nw.AddEdge(7, 8, Nr["MC"]);
    nw.AddEdge(9, 10, Nr["M-"]);
    nw.AddEdge(6, 7, 1e9);
    nw.AddEdge(6, 9, 1e9);
    nw.AddEdge(8, 5, 1e9);
    nw.AddEdge(8, 3, 1e9);
    nw.AddEdge(4, 11, 1e9);
    nw.AddEdge(6, 11, 1e9);
    nw.AddEdge(8, 11, 1e9);
    nw.AddEdge(10, 11, 1e9);

    vector<vector<int>> pizda_return = nw.pizda(0, 11);

    int count = 0;
    ostringstream answer;

    for(auto it: pizda_return) {
        vector<int> walk;
        for(auto it2: it) {
            if(it2 == 0 || it2 == 11) {
                continue;
            }
            if(it2 <= 2 || it2 % 2 == 1) {
                walk.push_back(mapula[ids_to_string_pula[it2]].back());
                mapula[ids_to_string_pula[it2]].pop_back();
            }
        }

        for(int i = 0; i < (int)walk.size(); i++) {
            count += 1;
            answer << "DRIVE " << walk[i] + 1 << "\n";
            if(depart[walk[i]] != '-') {
                count += 1;
                answer << "DROPOFF\n";
            }
            if(arrive[walk[i]] != '-') {
                count += 1;
                answer << "PICKUP\n";
            }
        }
    }

    cout << count << "\n";
    cout << answer.str();


    return 0;
}
